The wl_shell_surface interface

## Data Structures

struct | wl_shell_surface_listener

## Macros

#define | WL_SHELL_SURFACE_PING_SINCE_VERSION 1
#define | WL_SHELL_SURFACE_CONFIGURE_SINCE_VERSION 1
#define | WL_SHELL_SURFACE_POPUP_DONE_SINCE_VERSION 1
#define | WL_SHELL_SURFACE_PONG_SINCE_VERSION 1
#define | WL_SHELL_SURFACE_MOVE_SINCE_VERSION 1
#define | WL_SHELL_SURFACE_RESIZE_SINCE_VERSION 1
#define | WL_SHELL_SURFACE_SET_TOPLEVEL_SINCE_VERSION 1
#define | WL_SHELL_SURFACE_SET_TRANSIENT_SINCE_VERSION 1
#define | WL_SHELL_SURFACE_SET_FULLSCREEN_SINCE_VERSION 1
#define | WL_SHELL_SURFACE_SET_POPUP_SINCE_VERSION 1
#define | WL_SHELL_SURFACE_SET_MAXIMIZED_SINCE_VERSION 1
#define | WL_SHELL_SURFACE_SET_TITLE_SINCE_VERSION 1
#define | WL_SHELL_SURFACE_SET_CLASS_SINCE_VERSION 1

## Enumerations

enum | wl_shell_surface_resize { WL_SHELL_SURFACE_RESIZE_NONE = 0, WL_SHELL_SURFACE_RESIZE_TOP = 1, WL_SHELL_SURFACE_RESIZE_BOTTOM = 2, WL_SHELL_SURFACE_RESIZE_LEFT = 4, WL_SHELL_SURFACE_RESIZE_TOP_LEFT = 5, WL_SHELL_SURFACE_RESIZE_BOTTOM_LEFT = 6, WL_SHELL_SURFACE_RESIZE_RIGHT = 8, WL_SHELL_SURFACE_RESIZE_TOP_RIGHT = 9, WL_SHELL_SURFACE_RESIZE_BOTTOM_RIGHT = 10 }
enum | wl_shell_surface_transient { WL_SHELL_SURFACE_TRANSIENT_INACTIVE = 0x1 }
enum | wl_shell_surface_fullscreen_method { WL_SHELL_SURFACE_FULLSCREEN_METHOD_DEFAULT = 0, WL_SHELL_SURFACE_FULLSCREEN_METHOD_SCALE = 1, WL_SHELL_SURFACE_FULLSCREEN_METHOD_DRIVER = 2, WL_SHELL_SURFACE_FULLSCREEN_METHOD_FILL = 3 }

## Functions

static int | wl_shell_surface_add_listener (struct wl_shell_surface *wl_shell_surface, const struct wl_shell_surface_listener *listener, void *data)
static void | wl_shell_surface_set_user_data (struct wl_shell_surface *wl_shell_surface, void *user_data)
static void * | wl_shell_surface_get_user_data (struct wl_shell_surface *wl_shell_surface)
static void | wl_shell_surface_destroy (struct wl_shell_surface *wl_shell_surface)
static void | wl_shell_surface_pong (struct wl_shell_surface *wl_shell_surface, uint32_t serial)
static void | wl_shell_surface_move (struct wl_shell_surface *wl_shell_surface, struct wl_seat *seat, uint32_t serial)
static void | wl_shell_surface_resize (struct wl_shell_surface *wl_shell_surface, struct wl_seat *seat, uint32_t serial, uint32_t edges)
static void | wl_shell_surface_set_toplevel (struct wl_shell_surface *wl_shell_surface)
static void | wl_shell_surface_set_transient (struct wl_shell_surface *wl_shell_surface, struct wl_surface *parent, int32_t x, int32_t y, uint32_t flags)
static void | wl_shell_surface_set_fullscreen (struct wl_shell_surface *wl_shell_surface, uint32_t method, uint32_t framerate, struct wl_output *output)
static void | wl_shell_surface_set_popup (struct wl_shell_surface *wl_shell_surface, struct wl_seat *seat, uint32_t serial, struct wl_surface *parent, int32_t x, int32_t y, uint32_t flags)
static void | wl_shell_surface_set_maximized (struct wl_shell_surface *wl_shell_surface, struct wl_output *output)
static void | wl_shell_surface_set_title (struct wl_shell_surface *wl_shell_surface, const char *title)
static void | wl_shell_surface_set_class (struct wl_shell_surface *wl_shell_surface, const char *class_)

## Detailed Description

An interface that may be implemented by a wl_surface, for implementations that provide a desktop-style user interface.

It provides requests to treat surfaces like toplevel, fullscreen or popup windows, move, resize or maximize them, associate metadata like title and class, etc.

On the server side the object is automatically destroyed when the related wl_surface is destroyed. On the client side, wl_shell_surface_destroy() must be called before destroying the wl_surface object.

## Macro Definition Documentation

## WL_SHELL_SURFACE_CONFIGURE_SINCE_VERSION

#define WL_SHELL_SURFACE_CONFIGURE_SINCE_VERSION 1

Definition at line 2953 of file wayland-client-protocol.h.

## WL_SHELL_SURFACE_MOVE_SINCE_VERSION

#define WL_SHELL_SURFACE_MOVE_SINCE_VERSION 1

Definition at line 2966 of file wayland-client-protocol.h.

## WL_SHELL_SURFACE_PING_SINCE_VERSION

#define WL_SHELL_SURFACE_PING_SINCE_VERSION 1

Definition at line 2949 of file wayland-client-protocol.h.

## WL_SHELL_SURFACE_PONG_SINCE_VERSION

#define WL_SHELL_SURFACE_PONG_SINCE_VERSION 1

Definition at line 2962 of file wayland-client-protocol.h.

## WL_SHELL_SURFACE_POPUP_DONE_SINCE_VERSION

#define WL_SHELL_SURFACE_POPUP_DONE_SINCE_VERSION 1

Definition at line 2957 of file wayland-client-protocol.h.

## WL_SHELL_SURFACE_RESIZE_SINCE_VERSION

#define WL_SHELL_SURFACE_RESIZE_SINCE_VERSION 1

Definition at line 2970 of file wayland-client-protocol.h.

## WL_SHELL_SURFACE_SET_CLASS_SINCE_VERSION

#define WL_SHELL_SURFACE_SET_CLASS_SINCE_VERSION 1

Definition at line 2998 of file wayland-client-protocol.h.

## WL_SHELL_SURFACE_SET_FULLSCREEN_SINCE_VERSION

#define WL_SHELL_SURFACE_SET_FULLSCREEN_SINCE_VERSION 1

Definition at line 2982 of file wayland-client-protocol.h.

## WL_SHELL_SURFACE_SET_MAXIMIZED_SINCE_VERSION

#define WL_SHELL_SURFACE_SET_MAXIMIZED_SINCE_VERSION 1

Definition at line 2990 of file wayland-client-protocol.h.

## WL_SHELL_SURFACE_SET_POPUP_SINCE_VERSION

#define WL_SHELL_SURFACE_SET_POPUP_SINCE_VERSION 1

Definition at line 2986 of file wayland-client-protocol.h.

## WL_SHELL_SURFACE_SET_TITLE_SINCE_VERSION

#define WL_SHELL_SURFACE_SET_TITLE_SINCE_VERSION 1

Definition at line 2994 of file wayland-client-protocol.h.

## WL_SHELL_SURFACE_SET_TOPLEVEL_SINCE_VERSION

#define WL_SHELL_SURFACE_SET_TOPLEVEL_SINCE_VERSION 1

Definition at line 2974 of file wayland-client-protocol.h.

## WL_SHELL_SURFACE_SET_TRANSIENT_SINCE_VERSION

#define WL_SHELL_SURFACE_SET_TRANSIENT_SINCE_VERSION 1

Definition at line 2978 of file wayland-client-protocol.h.

## Enumeration Type Documentation

## wl_shell_surface_fullscreen_method

enum wl_shell_surface_fullscreen_method

different method to set the surface fullscreen

Hints to indicate to the compositor how to deal with a conflict between the dimensions of the surface and the dimensions of the output. The compositor is free to ignore this parameter.

Enumerator
WL_SHELL_SURFACE_FULLSCREEN_METHOD_DEFAULT | no preference, apply default policy
WL_SHELL_SURFACE_FULLSCREEN_METHOD_SCALE | scale, preserve the surface's aspect ratio and center on output
WL_SHELL_SURFACE_FULLSCREEN_METHOD_DRIVER | switch output mode to the smallest mode that can fit the surface, add black borders to compensate size mismatch
WL_SHELL_SURFACE_FULLSCREEN_METHOD_FILL | no upscaling, center on output and add black borders to compensate size mismatch

Definition at line 2849 of file wayland-client-protocol.h.

{
/**
* no preference, apply default policy
*/
WL_SHELL_SURFACE_FULLSCREEN_METHOD_DEFAULT = 0,
/**
* scale, preserve the surface's aspect ratio and center on output
*/
WL_SHELL_SURFACE_FULLSCREEN_METHOD_SCALE = 1,
/**
* switch output mode to the smallest mode that can fit the surface, add black borders to compensate size mismatch
*/
WL_SHELL_SURFACE_FULLSCREEN_METHOD_DRIVER = 2,
/**
* no upscaling, center on output and add black borders to compensate size mismatch
*/
WL_SHELL_SURFACE_FULLSCREEN_METHOD_FILL = 3,
};
WL_SHELL_SURFACE_FULLSCREEN_METHOD_DEFAULT
Definition: wayland-client-protocol.h:2853
WL_SHELL_SURFACE_FULLSCREEN_METHOD_FILL
Definition: wayland-client-protocol.h:2865
WL_SHELL_SURFACE_FULLSCREEN_METHOD_DRIVER
Definition: wayland-client-protocol.h:2861
WL_SHELL_SURFACE_FULLSCREEN_METHOD_SCALE
Definition: wayland-client-protocol.h:2857

## wl_shell_surface_resize

enum wl_shell_surface_resize

edge values for resizing

These values are used to indicate which edge of a surface is being dragged in a resize operation. The server may use this information to adapt its behavior, e.g. choose an appropriate cursor image.

Enumerator
WL_SHELL_SURFACE_RESIZE_NONE | no edge
WL_SHELL_SURFACE_RESIZE_TOP | top edge
WL_SHELL_SURFACE_RESIZE_BOTTOM | bottom edge
WL_SHELL_SURFACE_RESIZE_LEFT | left edge
WL_SHELL_SURFACE_RESIZE_TOP_LEFT | top and left edges
WL_SHELL_SURFACE_RESIZE_BOTTOM_LEFT | bottom and left edges
WL_SHELL_SURFACE_RESIZE_RIGHT | right edge
WL_SHELL_SURFACE_RESIZE_TOP_RIGHT | top and right edges
WL_SHELL_SURFACE_RESIZE_BOTTOM_RIGHT | bottom and right edges

Definition at line 2782 of file wayland-client-protocol.h.

{
/**
* no edge
*/
WL_SHELL_SURFACE_RESIZE_NONE = 0,
/**
* top edge
*/
WL_SHELL_SURFACE_RESIZE_TOP = 1,
/**
* bottom edge
*/
WL_SHELL_SURFACE_RESIZE_BOTTOM = 2,
/**
* left edge
*/
WL_SHELL_SURFACE_RESIZE_LEFT = 4,
/**
* top and left edges
*/
WL_SHELL_SURFACE_RESIZE_TOP_LEFT = 5,
/**
* bottom and left edges
*/
WL_SHELL_SURFACE_RESIZE_BOTTOM_LEFT = 6,
/**
* right edge
*/
WL_SHELL_SURFACE_RESIZE_RIGHT = 8,
/**
* top and right edges
*/
WL_SHELL_SURFACE_RESIZE_TOP_RIGHT = 9,
/**
* bottom and right edges
*/
WL_SHELL_SURFACE_RESIZE_BOTTOM_RIGHT = 10,
};
WL_SHELL_SURFACE_RESIZE_BOTTOM_RIGHT
Definition: wayland-client-protocol.h:2818
WL_SHELL_SURFACE_RESIZE_NONE
Definition: wayland-client-protocol.h:2786
WL_SHELL_SURFACE_RESIZE_TOP_RIGHT
Definition: wayland-client-protocol.h:2814
WL_SHELL_SURFACE_RESIZE_LEFT
Definition: wayland-client-protocol.h:2798
WL_SHELL_SURFACE_RESIZE_BOTTOM_LEFT
Definition: wayland-client-protocol.h:2806
WL_SHELL_SURFACE_RESIZE_TOP
Definition: wayland-client-protocol.h:2790
WL_SHELL_SURFACE_RESIZE_RIGHT
Definition: wayland-client-protocol.h:2810
WL_SHELL_SURFACE_RESIZE_TOP_LEFT
Definition: wayland-client-protocol.h:2802
WL_SHELL_SURFACE_RESIZE_BOTTOM
Definition: wayland-client-protocol.h:2794

## wl_shell_surface_transient

enum wl_shell_surface_transient

details of transient behaviour

These flags specify details of the expected behaviour of transient surfaces. Used in the set_transient request.

Enumerator
WL_SHELL_SURFACE_TRANSIENT_INACTIVE | do not set keyboard focus

Definition at line 2831 of file wayland-client-protocol.h.

{
/**
* do not set keyboard focus
*/
WL_SHELL_SURFACE_TRANSIENT_INACTIVE = 0x1,
};
WL_SHELL_SURFACE_TRANSIENT_INACTIVE
Definition: wayland-client-protocol.h:2835

## Function Documentation

## wl_shell_surface_add_listener()

static int wl_shell_surface_add_listener | ( | struct wl_shell_surface * | wl_shell_surface,
|  | const struct wl_shell_surface_listener * | listener,
|  | void * | data
| ) |  |

inline static

Definition at line 2928 of file wayland-client-protocol.h.

{
return wl_proxy_add_listener((struct wl_proxy *) wl_shell_surface,
(void (**)(void)) listener, data);
}
data
GLint GLenum GLsizei GLsizei GLsizei GLint GLsizei const GLvoid * data
Definition: SDL_opengl.h:1974

## wl_shell_surface_destroy()

static void wl_shell_surface_destroy | ( | struct wl_shell_surface * | wl_shell_surface | ) |

inline static

Definition at line 3022 of file wayland-client-protocol.h.

{
wl_proxy_destroy((struct wl_proxy *) wl_shell_surface);
}

## wl_shell_surface_get_user_data()

static void* wl_shell_surface_get_user_data | ( | struct wl_shell_surface * | wl_shell_surface | ) |

inline static

Definition at line 3009 of file wayland-client-protocol.h.

{
return wl_proxy_get_user_data((struct wl_proxy *) wl_shell_surface);
}

## wl_shell_surface_move()

static void wl_shell_surface_move | ( | struct wl_shell_surface * | wl_shell_surface,
|  | struct wl_seat * | seat,
|  | uint32_t | serial
| ) |  |

inline static

Start a pointer-driven move of the surface.

This request must be used in response to a button press event. The server may ignore move requests depending on the state of the surface (e.g. fullscreen or maximized).

Definition at line 3050 of file wayland-client-protocol.h.

References WL_SHELL_SURFACE_MOVE.

{
wl_proxy_marshal((struct wl_proxy *) wl_shell_surface,
WL_SHELL_SURFACE_MOVE, seat, serial);
}
WL_SHELL_SURFACE_MOVE
#define WL_SHELL_SURFACE_MOVE
Definition: wayland-client-protocol.h:2936

## wl_shell_surface_pong()

static void wl_shell_surface_pong | ( | struct wl_shell_surface * | wl_shell_surface,
|  | uint32_t | serial
| ) |  |

inline static

A client must respond to a ping event with a pong request or the client may be deemed unresponsive.

Definition at line 3034 of file wayland-client-protocol.h.

References WL_SHELL_SURFACE_PONG.

{
wl_proxy_marshal((struct wl_proxy *) wl_shell_surface,
WL_SHELL_SURFACE_PONG, serial);
}
WL_SHELL_SURFACE_PONG
#define WL_SHELL_SURFACE_PONG
Definition: wayland-client-protocol.h:2935

## wl_shell_surface_resize()

static void wl_shell_surface_resize | ( | struct wl_shell_surface * | wl_shell_surface,
|  | struct wl_seat * | seat,
|  | uint32_t | serial,
|  | uint32_t | edges
| ) |  |

inline static

Start a pointer-driven resizing of the surface.

This request must be used in response to a button press event. The server may ignore resize requests depending on the state of the surface (e.g. fullscreen or maximized).

Definition at line 3066 of file wayland-client-protocol.h.

References WL_SHELL_SURFACE_RESIZE.

{
wl_proxy_marshal((struct wl_proxy *) wl_shell_surface,
WL_SHELL_SURFACE_RESIZE, seat, serial, edges);
}
WL_SHELL_SURFACE_RESIZE
#define WL_SHELL_SURFACE_RESIZE
Definition: wayland-client-protocol.h:2937

## wl_shell_surface_set_class()

static void wl_shell_surface_set_class | ( | struct wl_shell_surface * | wl_shell_surface,
|  | const char * | class_
| ) |  |

inline static

Set a class for the surface.

The surface class identifies the general class of applications to which the surface belongs. A common convention is to use the file name (or the full path if it is a non-standard location) of the application's .desktop file as the class.

Definition at line 3236 of file wayland-client-protocol.h.

References WL_SHELL_SURFACE_SET_CLASS.

{
wl_proxy_marshal((struct wl_proxy *) wl_shell_surface,
WL_SHELL_SURFACE_SET_CLASS, class_);
}
WL_SHELL_SURFACE_SET_CLASS
#define WL_SHELL_SURFACE_SET_CLASS
Definition: wayland-client-protocol.h:2944

## wl_shell_surface_set_fullscreen()

static void wl_shell_surface_set_fullscreen | ( | struct wl_shell_surface * | wl_shell_surface,
|  | uint32_t | method,
|  | uint32_t | framerate,
|  | struct wl_output * | output
| ) |  |

inline static

Map the surface as a fullscreen surface.

If an output parameter is given then the surface will be made fullscreen on that output. If the client does not specify the output then the compositor will apply its policy - usually choosing the output on which the surface has the biggest surface area.

The client may specify a method to resolve a size conflict between the output size and the surface size - this is provided through the method parameter.

The framerate parameter is used only when the method is set to "driver", to indicate the preferred framerate. A value of 0 indicates that the client does not care about framerate. The framerate is specified in mHz, that is framerate of 60000 is 60Hz.

A method of "scale" or "driver" implies a scaling operation of the surface, either via a direct scaling operation or a change of the output mode. This will override any kind of output scaling, so that mapping a surface with a buffer size equal to the mode can fill the screen independent of buffer_scale.

A method of "fill" means we don't scale up the buffer, however any output scale is applied. This means that you may run into an edge case where the application maps a buffer with the same size of the output mode but buffer_scale 1 (thus making a surface larger than the output). In this case it is allowed to downscale the results to fit the screen.

The compositor must reply to this request with a configure event with the dimensions for the output on which the surface will be made fullscreen.

Definition at line 3142 of file wayland-client-protocol.h.

References WL_SHELL_SURFACE_SET_FULLSCREEN.

{
wl_proxy_marshal((struct wl_proxy *) wl_shell_surface,
WL_SHELL_SURFACE_SET_FULLSCREEN, method, framerate, output);
}
WL_SHELL_SURFACE_SET_FULLSCREEN
#define WL_SHELL_SURFACE_SET_FULLSCREEN
Definition: wayland-client-protocol.h:2940
sort_controllers.output
output
Definition: sort_controllers.py:10

## wl_shell_surface_set_maximized()

static void wl_shell_surface_set_maximized | ( | struct wl_shell_surface * | wl_shell_surface,
|  | struct wl_output * | output
| ) |  |

inline static

Map the surface as a maximized surface.

If an output parameter is given then the surface will be maximized on that output. If the client does not specify the output then the compositor will apply its policy - usually choosing the output on which the surface has the biggest surface area.

The compositor will reply with a configure event telling the expected new surface size. The operation is completed on the next buffer attach to this surface.

A maximized surface typically fills the entire output it is bound to, except for desktop elements such as panels. This is the main difference between a maximized shell surface and a fullscreen shell surface.

The details depend on the compositor implementation.

Definition at line 3201 of file wayland-client-protocol.h.

References WL_SHELL_SURFACE_SET_MAXIMIZED.

{
wl_proxy_marshal((struct wl_proxy *) wl_shell_surface,
WL_SHELL_SURFACE_SET_MAXIMIZED, output);
}
WL_SHELL_SURFACE_SET_MAXIMIZED
#define WL_SHELL_SURFACE_SET_MAXIMIZED
Definition: wayland-client-protocol.h:2942
sort_controllers.output
output
Definition: sort_controllers.py:10

## wl_shell_surface_set_popup()

static void wl_shell_surface_set_popup | ( | struct wl_shell_surface * | wl_shell_surface,
|  | struct wl_seat * | seat,
|  | uint32_t | serial,
|  | struct wl_surface * | parent,
|  | int32_t | x,
|  | int32_t | y,
|  | uint32_t | flags
| ) |  |

inline static

Map the surface as a popup.

A popup surface is a transient surface with an added pointer grab.

An existing implicit grab will be changed to owner-events mode, and the popup grab will continue after the implicit grab ends (i.e. releasing the mouse button does not cause the popup to be unmapped).

The popup grab continues until the window is destroyed or a mouse button is pressed in any other client's window. A click in any of the client's surfaces is reported as normal, however, clicks in other clients' surfaces will be discarded and trigger the callback.

The x and y arguments specify the location of the upper left corner of the surface relative to the upper left corner of the parent surface, in surface-local coordinates.

Definition at line 3172 of file wayland-client-protocol.h.

References WL_SHELL_SURFACE_SET_POPUP.

{
wl_proxy_marshal((struct wl_proxy *) wl_shell_surface,
WL_SHELL_SURFACE_SET_POPUP, seat, serial, parent, x, y, flags);
}
x
GLint GLint GLint GLint GLint x
Definition: SDL_opengl.h:1574
y
GLint GLint GLint GLint GLint GLint y
Definition: SDL_opengl.h:1574
flags
GLbitfield flags
Definition: SDL_opengl_glext.h:1480
WL_SHELL_SURFACE_SET_POPUP
#define WL_SHELL_SURFACE_SET_POPUP
Definition: wayland-client-protocol.h:2941

## wl_shell_surface_set_title()

static void wl_shell_surface_set_title | ( | struct wl_shell_surface * | wl_shell_surface,
|  | const char * | title
| ) |  |

inline static

Set a short title for the surface.

This string may be used to identify the surface in a task bar, window list, or other user interface elements provided by the compositor.

The string must be encoded in UTF-8.

Definition at line 3219 of file wayland-client-protocol.h.

References WL_SHELL_SURFACE_SET_TITLE.

{
wl_proxy_marshal((struct wl_proxy *) wl_shell_surface,
WL_SHELL_SURFACE_SET_TITLE, title);
}
WL_SHELL_SURFACE_SET_TITLE
#define WL_SHELL_SURFACE_SET_TITLE
Definition: wayland-client-protocol.h:2943

## wl_shell_surface_set_toplevel()

static void wl_shell_surface_set_toplevel | ( | struct wl_shell_surface * | wl_shell_surface | ) |

inline static

Map the surface as a toplevel surface.

A toplevel surface is not fullscreen, maximized or transient.

Definition at line 3080 of file wayland-client-protocol.h.

References WL_SHELL_SURFACE_SET_TOPLEVEL.

{
wl_proxy_marshal((struct wl_proxy *) wl_shell_surface,
WL_SHELL_SURFACE_SET_TOPLEVEL);
}
WL_SHELL_SURFACE_SET_TOPLEVEL
#define WL_SHELL_SURFACE_SET_TOPLEVEL
Definition: wayland-client-protocol.h:2938

## wl_shell_surface_set_transient()

static void wl_shell_surface_set_transient | ( | struct wl_shell_surface * | wl_shell_surface,
|  | struct wl_surface * | parent,
|  | int32_t | x,
|  | int32_t | y,
|  | uint32_t | flags
| ) |  |

inline static

Map the surface relative to an existing surface.

The x and y arguments specify the location of the upper left corner of the surface relative to the upper left corner of the parent surface, in surface-local coordinates.

The flags argument controls details of the transient behaviour.

Definition at line 3098 of file wayland-client-protocol.h.

References WL_SHELL_SURFACE_SET_TRANSIENT.

{
wl_proxy_marshal((struct wl_proxy *) wl_shell_surface,
WL_SHELL_SURFACE_SET_TRANSIENT, parent, x, y, flags);
}
x
GLint GLint GLint GLint GLint x
Definition: SDL_opengl.h:1574
y
GLint GLint GLint GLint GLint GLint y
Definition: SDL_opengl.h:1574
WL_SHELL_SURFACE_SET_TRANSIENT
#define WL_SHELL_SURFACE_SET_TRANSIENT
Definition: wayland-client-protocol.h:2939
flags
GLbitfield flags
Definition: SDL_opengl_glext.h:1480

## wl_shell_surface_set_user_data()

static void wl_shell_surface_set_user_data | ( | struct wl_shell_surface * | wl_shell_surface,
|  | void * | user_data
| ) |  |

inline static

Definition at line 3002 of file wayland-client-protocol.h.

{
wl_proxy_set_user_data((struct wl_proxy *) wl_shell_surface, user_data);
}